<?

/*
 * au: vitas @ matfyz . cz
 * version 0.0.2
 */

/**
 * options:
 * wgAsciiTranslitExtensionHack -- sometimes iconv does not work
 * wgAsciiTranslitExtensionHideRedir -- hide 'Redirected from' when
 *    redirecting from transliterated 
 * wgAsciiTranslitExtensionNS -- translit also namespace names
 *
 */


#####################################################################################################
# Special page class

require_once "$IP/includes/SpecialPage.php";

class Ate_SpecialPage extends SpecialPage {

	var $maxPerPage = 900;
	var $tab_tf = array(); # to => from
	var $tab_tf2 = array(); # root => from2+
	var $tab_ft = array(); # from => to

	function Ate_SpecialPage() {
		SpecialPage::SpecialPage('AsciiTranslitExtension');
	}


	function execute($params) {
		global $wgOut;
		$this->setHeaders();
		$this->showChunk('','',true);
		return true;
	}

   function showChunk_select($namespace, $from, $sk) {
	global $wgUser;
	$fname = 'ATE::select';

	$sk = $wgUser->getSkin();

	$fromTitle = null;
	if ($from!="") {
		$fromTitle = Title::newFromURL( $from );
		if (!$fromTitle) {
			return;
		}
		$fromNS = $fromTitle->getNamespace();
		if ($namespace == NS_MAIN)
			$namespace = $fromNS;
	}
	$fromKey = is_null( $fromTitle ) ? '' : $fromTitle->getDBkey();

	$dbr =& wfGetDB( DB_SLAVE );
	$res = $dbr->select( 'page',
		array( 'page_namespace', 'page_title', 'page_is_redirect' ),
		array(
			'page_namespace' => $namespace,
			'page_title >= ' . $dbr->addQuotes( $fromKey )
		),
		$fname,
		array(
			'ORDER BY'  => 'page_title',
			'LIMIT'     => $this->maxPerPage + 1,
			'USE INDEX' => 'name_title',
		)
	);
	return array($res, $dbr, $sk);
    }
   /**
    * @param string $form, $to
    */
   function showChunk_including($namespace, $including, $dbr) {
	global $wgContLang;
	if ( $including ) {
		$out2 = '';
	} else {
		#$nsForm = $this->namespaceForm ( $namespace, $from );
		$out2 = '<table style="background: inherit;" width="100%" cellpadding="0" cellspacing="0" border="0">';
		$out2 .= '<tr valign="top"><td align="left">';
		$out2 .= '</td><td align="right" style="font-size: smaller; margin-bottom: 1em;">' .
				$sk->makeKnownLink( $wgContLang->specialPage( "Allpages" ),
					wfMsgHtml ( 'allpages' ) );
		if ( ($n == $this->maxPerPage) && ($s = $dbr->fetchObject( $res )) ) {
			$namespaceparam = $namespace ? "&namespace=$namespace" : "";
			$out2 .= " | " . $sk->makeKnownLink(
				$wgContLang->specialPage( "Allpages" ),
				wfMsgHtml ( 'nextpage', $s->page_title ),
				"from=" . wfUrlEncode ( $s->page_title ) . $namespaceparam );
		}
		$out2 .= "</td></tr></table><hr />";
	}

	return $out2;
    }

    function showChunk_link($sk, $t, $s) {
	$link = '';
	if( $s->page_is_redirect ) {
		$link = '<div class="allpagesredirect">';
		$t_text = $t->getText();
		$link .= $sk->makeKnownLinkObj(
				$t, htmlspecialchars(
				$t_text), false, false);
		$art = new Article($t);
		$text = $art->fetchContent();
		if(eregi('#redirect \[\[(.*)\]\]',$text, $reg)){
			$red_to = $reg[1];
			$link .= "(>$red_to,$t_text)";
			$this->tab_add($t_text,$red_to);
		}
		$link .="</div>";

	} else {
		$link = $sk->makeKnownLinkObj(
				$t, htmlspecialchars(
				$t->getText() ), false, false);
	}
    	return $link;
    }

    function do_Chunk_link($sk, $t, $s) {
	$t_text = $t->getText();
	if( $s->page_is_redirect ) {
		$art = new Article($t);
		$text = $art->fetchContent();
		if(eregi('#redirect \[\[(.*)\]\]',$text, $reg)){
			$red_to = $reg[1];
			$this->tab_add($t_text,$red_to);
		} 

	} else {
		$this->tab_add_empty($t_text);
	}
    }

    function tab_prone()
    {

	foreach($this->tab_tf as $root => $froms) {
		if( array_key_exists($root, $this->tab_ft) ) {
			continue;
		}
		#root is root
		foreach($froms as $from) { 
			$this->tab_prone2($root, $from, 1);
		}
	}
    }

    function tab_prone2($root, $cur, $dep) {
	if( $dep > 100) {
		gfDebug("ate: recursion to deep $dep\n");
		return;
	}
	if( !array_key_exists($cur, $this->tab_tf) ) {
		return;
	}
	$this->tab_add2($root,$this->tab_tf[$cur]);
	foreach($this->tab_tf[$cur] as $from) {
		$this->tab_prone2($root,$from,$dep+1);
	}
    }

    function tab_add_empty($to) {

	$to = str_replace(' ', '_', $to);
	if( array_key_exists($to, $this->tab_tf) ) {
		return;
	}
	$this->tab_tf[$to] = array();
    }

    function tab_add($from, $to)
    {
	$to = str_replace(' ', '_', $to);
	$from = str_replace(' ', '_', $from);
	$this->tab_ft[$from] = $to;

	if( !array_key_exists($to, $this->tab_tf) ) {
		$this->tab_tf[$to] = array($from);
		return;
	}
	$this->tab_tf[$to][] = $from;
    }

    function tab_add2($root, $array) {

	if( !array_key_exists($root, $this->tab_tf2) ) {
		$this->tab_tf2[$root] = array();
	}
	foreach($array as $a ){
		$this->tab_tf2[$root][] = $a;
	}
    }

    function redtab_print($sk)
    {
	$this->tab_prone();
	$out = array('0'=> '', '+'=>'','!'=>'' );
	global $wfTransliterateText;
	foreach($this->tab_tf as $to => $froms) {


		if( array_key_exists($to, $this->tab_ft) ){
			continue;
		}

		$to_asc = $wfTransliterateText($to);
		$type= $this->has_ate($to);

		$out[$type] .=  "<li> ". $this->page_print($sk, $to) .
			"(". count($froms) . ")";
		foreach($froms as $from) {
			if($to_asc == $from) {
				continue;
			}
			$out[$type].= "< " . $this->page_print($sk, $from);
		}
		if( array_key_exists($to, $this->tab_tf2) ) {
			$out[$type].= "((". count($this->tab_tf2[$to]). "))";
			foreach($this->tab_tf2[$to] as $from) {
				$out[$type].= "<< ". $this->page_print($sk,$from);
			}
		}
		$out[$type] .="</li>\n";
	}
	$ret = '';
	$ret .= "Need ATE:\n<ul>".$out['!']. "</ul>\n";
	$ret .= "Need not ATE:\n<ul>".$out['0']. "</ul>\n";
	$ret .= "Has ATE:\n<ul>".$out['+'].  "</ul>\n";
	#$ret .= implode(' ', array_keys($this->tab_tf));
	return $ret;
    }


    function has_ate($page)
    {
	global $wfTransliterateText;
	$page_asc = $wfTransliterateText($page);

	if( $page_asc == $page ) {
		return "0";
	}

	$page_asc_re = $this->tab_ft[$page_asc];
	if( isset($page_asc_re) && $page_asc_re == $page ) {
		return "+";
	}
	return "!";
    }

    function page_print($sk, $page)
    {
	global $wfTransliterateText;
	
	$page_asc = $wfTransliterateText($page);
	$ret  =  $sk->makeKnownLink($page);
	$ret .= " (";
	$ret .= $sk->makeKnownLink($page_asc, 'A', 'action=edit');
	$ret .= $sk->makeKnownLink($page, 'E', 'action=edit');
	$ret .= $sk->makeKnownLink('Special:Movepage', 'M', "target=$page");
	$ret .= $sk->makeKnownLink($page, 'D', 'action=delete');
	$ret .= $sk->makeKnownLink('Special:Whatlinkshere', 'W', "target=$page");
	$ret .= ")";;
	return $ret;

	
    }

    function showChunk( $namespace = NS_MAIN, $from, $including = false ) {
	global $wgOut, $wgUser, $wgContLang;

	$fname = 'ATE::showChunk';

	list($res,$dbr, $sk) = $this->showChunk_select($namespace, $from, $sk);

	### FIXME: side link to previous

	$namespaces = $wgContLang->getFormattedNamespaces();
	while( $s = $dbr->fetchObject( $res )  ) {
		$t = Title::makeTitle( $s->page_namespace, $s->page_title );
		if( $t ) {
			$this->do_Chunk_link($sk, $t, $s);
		}
	}

	$out = $this->redtab_print($sk);
	$wgOut->addHtml( $out );
    }
}


#####################################################################################################
# hooks and related 

/**
 * When creating new page, create also redirection article from
 * 'transliterated' page name
 *
 * @param Article $article 
 * @param User $user
 * @param string $text
 * @param string $summary
 * @param bool $isminor
 * @param bool $watchthis
 * @param null $bool 
 *
 */
function ate_ArticleInsertComplete_hook(
		$article, $user, $text,
		$summary, $isminor,
		$watchthis, $null )
{
	$title = $article->mTitle;
	#wfDebug("ArticleInsertComplete:ns:$title->mNamespace,
	#	title:$title, $user->mName\n");

	ate_create_redirect($title, $text);
}


/**
 * @param String $text
 */
function ate_is_redirect($text) {

	$titleObj = Title::newFromRedirect( $text );
	return $titleObj !== NULL;
}

/**
 * @param Title $title
 * @param string $title
 */
function ate_create_redirect($title, $text = '') 
{
	global $wfTransliterateText;
	$key = $title->getDBkey();
	$key_asc = $wfTransliterateText( $key );

	if( $key == $key_asc ) {
		# also anti recursion, check
		wfDebug("ArticleInsertComplete: '$key' == '$key_asc'");
		return true;
	}

	# paranoia-check:  sth wrong with wfTransliterateText ?
	$key_asc_asc = $wfTransliterateText( $key_asc );
	if( $key_asc_asc != $key_asc ) {
		wfDebug("ArticleInsertComplete: wrong TransliterateText(), ".
			"T(T(t)) should eq T(t) $key_asc_asc ne $key_asc\n");
		return true;
	}
	$title_asc = Title::makeTitleSafe($title->mNamespace,$key_asc);

	$aid = $title_asc->getArticleID(GAID_FOR_UPDATE);

	if( $aid != 0 ) {
		#allready exists, let it be
		return true;
	}

	global $wgOut;
	if( $text != '' && ate_is_redirect( $text ) ) {
		# article is redirect: redirect directly to redirection :)
		$redirect = 'redirect=no';
		$text_asc = $text;
	} else {
		$redirect = 'redirect=yes'; # prevent getFullURL from trans
		$text_asc = "#redirect [[$key]]";
	}

	$article_asc = new Article($title_asc);
	$article_asc->insertNewArticle(
			$text_asc,
			"created by AsciiTranslitExtension",
			true,  false, false, $false);

	#hack: back to original redirect (last wins)
	$wgOut->redirect( $article_asc->mTitle->getFullURL( $redirect ) );
}

/**
 *
 * @param MovePageForm form
 * @param Title $old, $new
 */
function ate_SpecialMovepageAfterMove_hook($form, $old, $new)
{
	ate_create_redirect($new);
}

/**
 * rewrite URL to poit to transliterated names,
 * @param Title $title -- orig title
 * @param string $url
 * @param string $query --  no transliteration if nonempty
 */
function ate_GetLocalURL_hook($title, $url, $query)
{
	global $wgArticlePath;
	global $wfTransliterateText;

	if ( $title->isExternal() ) {
		return;
	}
	if ( $title->mNamespace != '' ) {
		# FIXME: only real namespace
		return;
	}
	$link_cache =& LinkCache::singleton();

	if( 0 == $link_cache->addLinkObj($title) ) {
		#title does not exist
		return;
	}
	if( $query != '' ) {
		# more complicated url does not
		return;
	}

	$dbkey =  $title->getPrefixedDBkey();
	#wfDebug("GetLocallURL-dbkey: $dbkey\n");

	$dbkey = $wfTransliterateText($dbkey);

	$url = str_replace( '$1', $dbkey, $wgArticlePath);

	#wfDebug("GetLocallURL-modified: $url, q='$query'\n");
	#wfDebug("GetLocallURL-modified: aid: $title->mArticleID\n");
	#wfDebugDieBacktrace();
}

/**
 * do not show 'Redirected from XXX' when it is translit case
 * @param Article $article 
 * @return true -> show 'redirected from',  false -> be quiet
 */
function ate_ArticleViewRedirect_hook($article)
{
	global $wfTransliterateText;

	$title_re = $article->mRedirectedFrom;
	$title  = $article->mTitle;

	$key_re = $title_re->getPrefixedDBkey();
	$key = $title->getPrefixedDBkey();
	$key_asc = $wfTransliterateText($key);

	wfDebug("ArticleVeiewRedirect: $key, $key_re, $key_asc\n");

	if( $key_asc == $key_re ) {
		return false;
	}
	return true;
}

#function ate_GetFullURL_hook($title, $url, $query)
#{
#	wfDebug("GetFullURL: $url, q='$query'\n");
#}
#
#function ate_GetInternalURL_hook($title, $url, $query)
#{
#	wfDebug("GetInternalURL: $url, q='$query'\n");
#}


##############################################################################
# translit functions

/**
 * Transliteration itself
 * @param strin $txt
 * @return transliterated text 
 */

function wfTransliterateText_iconv($txt)  {
	return  iconv ("UTF-8", "ASCII//TRANSLIT", $txt);
}

/**
 * Transliteration itself
 * on my system iconv does not work as explained in manual, so for now
 * here is Czech-charaters-translit-hack:
 * @param strin $txt
 * @return transliterated text 
 */
function wfTransliterateText_hack($txt)  {
	
	global $translit_hack_fr;
	global $translit_hack_to;

	$ret = str_replace(
		$translit_hack_fr,
		$translit_hack_to,
		$txt);
	return $ret;
}


##########################################################################
# init functions

function ate_Init() {

	global $wgHooks;
	global $wgAsciiTranslitExtensionHideRedir;
	global $wgAsciiTranslitExtensionHack;
	global $wgAsciiTranslitExtensionNS;

	$wgHooks['ArticleInsertComplete'][] = 'ate_ArticleInsertComplete_hook';
	$wgHooks['GetLocalURL'][] = 'ate_GetLocalURL_hook';
	$wgHooks['SpecialMovepageAfterMove'][] =
			'ate_SpecialMovepageAfterMove_hook';

	if( $wgAsciiTranslitExtensionHideRedir ) {
		$wgHooks['ArticleViewRedirect'][] =
			'ate_ArticleViewRedirect_hook';
	}


        SpecialPage::addPage(new Ate_SpecialPage() );

	ate_init_messages();

	if( isset($wgAsciiTranslitExtensionNS) && $wgAsciiTranslitExtensionNS ) {
		ate_init_ns();
	}
}

function ate_init_messages() {
	global $wgMessageCache;
	$wgMessageCache->addMessages( array(
		'asciitranslitextension' => 'Ascii Translit Extension',

	  ));
}


/*
 * translit namespace
 * forse ContLang to load() locales, and than dirtly write to its
 * tables
 */
function ate_init_ns() {

	global $wgContLang;
	global $wfTransliterateText;

	#wfDebug("ATE: specialni: '".$wgExtraNamespaces[-1]."' \n");
	#wfDebug("ATE: specialni: '".$wgNamespaceAliases['Speciální']."' \n");

	$ns = $wgContLang->getNamespaces();

	foreach($ns as $id => $name) {
		$name_asc = $wfTransliterateText($name);
		$wgContLang->namespaceNames[$id]= $name_asc;
		$wgContLang->mNamespaceIds[strtolower($name_asc)]= $id;
		wfDebug("ATE: $id -> $name_asc (was: $name)\n");
	}

	#$wgContLang->namespaceNames[-1]= 'Specialni';
	#$wgContLang->mNamespaceIds['Specialni']= -1;

	#$wgNamespaceAliases['specialni'] = -1;
	#$wgNamespaceAliases['Speciální'] = -1;
	#$wgExtraNamespaces[-1] = 'Specialni';
}

/*
 * init translit_hack_fr and _to arrays
 */
function ate_init_translit_hack() {
	global $wfTransliterateText;
	global $translit_hack_to;
	global $translit_hack_fr;
	global $translit_hack_table;

	$wfTransliterateText = 'wfTransliterateText_hack';

	# create tables for str_replace
	$translit_hack_to = array();
	$translit_hack_fr = array();
	foreach($translit_hack_table as $key => $val) {
		array_push($translit_hack_fr, $key);
		array_push($translit_hack_to, $val);
	}
}

# iso-8859-1 -16 latin letters
$translit_hack_table = array(
 "\xc4\x84"=>'A', "\xc3\x82"=>'A', "\xc3\x80"=>'A', "\xc3\x84"=>'A',
 "\xc3\x86"=>'A', "\xc3\x83"=>'A', "\xc4\x82"=>'A', "\xc3\x81"=>'A',
 "\xc3\x85"=>'A', "\xc4\x80"=>'A', "\xc4\x81"=>'a', "\xc3\xa4"=>'a',
 "\xc3\xa2"=>'a', "\xc3\xa0"=>'a', "\xc3\xa3"=>'a', "\xc3\xa5"=>'a',
 "\xc4\x85"=>'a', "\xc4\x83"=>'a', "\xc3\xa6"=>'a', "\xc3\xa1"=>'a',
 "\xc4\x88"=>'C', "\xc4\x8c"=>'C', "\xc4\x8a"=>'C', "\xc4\x86"=>'C',
 "\xc3\x87"=>'C', "\xc3\xa7"=>'c', "\xc4\x89"=>'c', "\xc4\x8d"=>'c',
 "\xc4\x87"=>'c', "\xc4\x8b"=>'c', "\xc4\x8e"=>'D', "\xc4\x90"=>'D',
 "\xc4\xb1"=>'d', "\xc4\x91"=>'d', "\xc4\x8f"=>'d', "\xc3\x8a"=>'E',
 "\xc4\x9a"=>'E', "\xc3\x8b"=>'E', "\xc3\x88"=>'E', "\xc3\x90"=>'E',
 "\xc3\x89"=>'E', "\xc4\x98"=>'E', "\xc4\x96"=>'E', "\xc4\x92"=>'E',
 "\xc5\x8a"=>'E', "\xc5\x8b"=>'e', "\xc3\xb0"=>'e', "\xc4\x99"=>'e',
 "\xc3\xab"=>'e', "\xc3\xa9"=>'e', "\xc4\x9b"=>'e', "\xc4\x97"=>'e',
 "\xc4\x93"=>'e', "\xc3\xaa"=>'e', "\xc3\xa8"=>'e', "\xc4\x9e"=>'G',
 "\xc4\xa0"=>'G', "\xc4\x9c"=>'G', "\xc4\xa2"=>'G', "\xc4\x9f"=>'g',
 "\xc4\xa1"=>'g', "\xc4\x9d"=>'g', "\xc4\xa3"=>'g', "\xc4\xa6"=>'H',
 "\xc4\xa4"=>'H', "\xc4\xa7"=>'h', "\xc4\xa5"=>'h', "\xc3\x8f"=>'I',
 "\xc3\x8c"=>'I', "\xc3\x8e"=>'I', "\xc4\xb0"=>'I', "\xc3\x8d"=>'I',
 "\xc4\xae"=>'I', "\xc4\xa8"=>'I', "\xc4\xaa"=>'I', "\xc3\xac"=>'i',
 "\xc4\xab"=>'i', "\xc3\xae"=>'i', "\xc4\xa9"=>'i', "\xc3\xaf"=>'i',
 "\xc4\xaf"=>'i', "\xc3\xad"=>'i', "\xc4\xb4"=>'J', "\xc4\xb5"=>'j',
 "\xc4\xb6"=>'K', "\xc4\xb8"=>'k', "\xc4\xb7"=>'k', "\xc4\xbd"=>'L',
 "\xc5\x81"=>'L', "\xc4\xb9"=>'L', "\xc4\xbb"=>'L', "\xc4\xba"=>'l',
 "\xc4\xbe"=>'l', "\xc4\xbc"=>'l', "\xc5\x82"=>'l', "\xc5\x87"=>'N',
 "\xc5\x83"=>'N', "\xc3\x91"=>'N', "\xc5\x85"=>'N', "\xc5\x88"=>'n',
 "\xc5\x86"=>'n', "\xc3\xb1"=>'n', "\xc5\x84"=>'n', "\xc3\x94"=>'O',
 "\xc3\x98"=>'O', "\xc3\x96"=>'O', "\xc3\x92"=>'O', "\xc3\x95"=>'O',
 "\xc5\x90"=>'O', "\xc3\x93"=>'O', "\xc5\x8c"=>'O', "\xc3\xb4"=>'o',
 "\xc3\xb5"=>'o', "\xc5\x91"=>'o', "\xc5\x8d"=>'o', "\xc3\xb3"=>'o',
 "\xc3\xb6"=>'o', "\xc3\xb2"=>'o', "\xc3\xb8"=>'o', "\xc5\x94"=>'R',
 "\xc5\x98"=>'R', "\xc5\x96"=>'R', "\xc5\x97"=>'r', "\xc5\x95"=>'r',
 "\xc5\x99"=>'r', "\xc5\x9e"=>'S', "\xc5\xa0"=>'S', "\xc5\x9a"=>'S',
 "\xc5\x9c"=>'S', "\xc8\x98"=>'S', "\xc3\x9f"=>'s', "\xc8\x99"=>'s',
 "\xc5\x9d"=>'s', "\xc5\x9f"=>'s', "\xc5\x9b"=>'s', "\xc5\xa1"=>'s',
 "\xc5\xa6"=>'T', "\xc5\xa2"=>'T', "\xc5\xa4"=>'T', "\xc8\x9a"=>'T',
 "\xc3\x9e"=>'T', "\xc5\xa3"=>'t', "\xc5\xa7"=>'t', "\xc5\xa5"=>'t',
 "\xc3\xbe"=>'t', "\xc8\x9b"=>'t', "\xc5\xb0"=>'U', "\xc3\x99"=>'U',
 "\xc5\xa8"=>'U', "\xc5\xaa"=>'U', "\xc3\x9a"=>'U', "\xc3\x9c"=>'U',
 "\xc5\xae"=>'U', "\xc5\xac"=>'U', "\xc5\xb2"=>'U', "\xc3\x9b"=>'U',
 "\xc3\xba"=>'u', "\xc5\xb3"=>'u', "\xc3\xb9"=>'u', "\xc3\xbc"=>'u',
 "\xc5\xa9"=>'u', "\xc5\xab"=>'u', "\xc5\xb1"=>'u', "\xc3\xbb"=>'u',
 "\xc5\xaf"=>'u', "\xc5\xad"=>'u', "\xc5\xb4"=>'W', "\xc5\xb5"=>'w',
 "\xc5\xb8"=>'Y', "\xc5\xb6"=>'Y', "\xc3\x9d"=>'Y', "\xc3\xbf"=>'y',
 "\xc3\xbd"=>'y', "\xc5\xb7"=>'y', "\xc5\xbb"=>'Z', "\xc5\xb9"=>'Z',
 "\xc5\xbd"=>'Z', "\xc5\xbe"=>'z', "\xc5\xbc"=>'z', "\xc5\xba"=>'z',


"\xd0\x90" => "A",      "\xd0\xb0" => "a",
"\xd0\x91" => "B",      "\xd0\xb1" => "b",
"\xd0\x92" => "V",      "\xd0\xb2" => "v",
"\xd0\x93" => "G",      "\xd0\xb3" => "g",
"\xd0\x94" => "D",      "\xd0\xb4" => "d",
"\xd0\x95" => "Je",     "\xd0\xb5" => "je",
"\xd0\x81" => "Jo",     "\xd1\x91" => "jo",
"\xd0\x96" => "Zh",     "\xd0\xb6" => "zh",
"\xd0\x97" => "Z",      "\xd0\xb7" => "z",
"\xd0\x98" => "I",      "\xd0\xb8" => "i",
"\xd0\x99" => "J",      "\xd0\xb9" => "j",
"\xd0\x9a" => "K",      "\xd0\xba" => "k",
"\xd0\x9b" => "L",      "\xd0\xbb" => "l",
"\xd0\x9c" => "M",      "\xd0\xbc" => "m",
"\xd0\x9d" => "N",      "\xd0\xbd" => "n",
"\xd0\x9e" => "O",      "\xd0\xbe" => "o",
"\xd0\x9f" => "P",      "\xd0\xbf" => "p",
"\xd0\xa0" => "R",      "\xd1\x80" => "r",
"\xd0\xa1" => "S",      "\xd1\x81" => "s",
"\xd0\xa2" => "T",      "\xd1\x82" => "t",
"\xd0\xa3" => "U",      "\xd1\x83" => "u",
"\xd0\xa4" => "F",      "\xd1\x84" => "f",
"\xd0\xa5" => "X",      "\xd1\x85" => "x",
"\xd0\xa6" => "Ts",     "\xd1\x86" => "ts",
"\xd0\xa7" => "Ch",     "\xd1\x87" => "ch",
"\xd0\xa8" => "Sh",     "\xd1\x88" => "sh",
"\xd0\xa9" => "Th",     "\xd1\x89" => "th",
"\xd0\xaa" => "''",     "\xd1\x8a" => "''",
"\xd0\xab" => "Y",      "\xd1\x8b" => "y",
"\xd0\xac" => "'",      "\xd1\x8c" => "'",
"\xd0\xad" => "E",      "\xd1\x8d" => "e",
"\xd0\xae" => "Ju",     "\xd1\x8e" => "ju",
"\xd0\xaf" => "Ja",     "\xd1\x8f" => "ja",

#	"\xc3\xa1" => "a", "\xc3\x81" => "A",
#	"\xc4\x8d" => "c", "\xc4\x8c" => "C",
#	"\xc4\x8f" => "d", "\xc4\x8e" => "D",
#	"\xc3\xa9" => "e", "\xc3\x89" => "E",
#	"\xc4\x9b" => "e", "\xc4\x9a" => "E",
#	"\xc3\xad" => "i", "\xc3\x8d" => "I",
#	"\xc5\x88" => "n", "\xc5\x87" => "N",
#	"\xc3\xb3" => "o", "\xc3\x93" => "O",
#	"\xc5\x99" => "r", "\xc5\x98" => "R",
#	"\xc5\xa1" => "s", "\xc5\xa0" => "S",
#	"\xc5\xa5" => "t", "\xc5\xa4" => "T",
#	"\xc3\xba" => "u", "\xc3\x9a" => "U",
#	"\xc5\xaf" => "u", "\xc5\xae" => "U",
#	"\xc3\xbd" => "y", "\xc3\x9d" => "Y",
#	"\xc5\xbe" => "z", "\xc5\xbd" => "Z",

);

##########################################################################
# main

# transl function
$wfTransliterateText = 'wfTransliterateText_iconv';
if( isset($wgAsciiTranslitExtensionHack) && $wgAsciiTranslitExtensionHack ) {
	ate_init_translit_hack();
}

# translit namespaces? default = yes
if( !isset($wgAsciiTranslitExtensionNS) ) {
	$wgAsciiTranslitExtensionNS = true;
}

# init later
$wgExtensionFunctions[] = 'ate_Init';

?>


